<?php
/*
Plugin Name: AgeCal-JIN
Plugin URI: http://www.tabibitojin.com
Description: 年齢を自動計算して表示する
Author: Jin
Version: 1.0.0
Author URI: http://www.tabibitojin.com
*/

//年月日の形式 2016年01月02日 または　20160102
//数字は全角でも半角でもOK

/* -----------------------------------
書式変換：　2010年01月01日　→　20100101
----------------------------------- */
function agecal_jin_20160901_normalizedate( $inStr ) {
	//全角数字があれば半角数字へ
	$inStr = mb_convert_kana($inStr, 'n');
	
    // 年月日の各パーツを分割する
    preg_match( "/([0-9]*)年([0-9]*)月([0-9]*)日/", $inStr, $data );

    if ( Count( $data ) != 4 ) { //形式が20100101の場合
        return $inStr;
    }else{ // 形式が2010年01月01日の場合	
		// 先頭0埋めでYYYYMMDD形式の日付文字列に変換する
		$outStr = sprintf( "%04.4d%02.2d%02.2d", $data[1], $data[2], $data[3] );
		return $outStr;
	}
}

/* -----------------------------------
年齢計算
----------------------------------- */
function agecal_jin_20160901_howold($atts) {
	extract(shortcode_atts(array(
		'ymd' => '20100101',	//初期値
	), $atts));

	$ymd = agecal_jin_20160901_normalizedate($ymd);
	$age = (int)((date('Ymd') - $ymd) / 10000);
	return $age;
}
add_shortcode('jToshi', 'agecal_jin_20160901_howold');
